// intentaremos resolver https://omegaup.com/arena/problem/lsp/#problems
#include <stdio.h>

struct coordenada {
   int fila;
   int columna;
};

int main( ) {
   int lobos, n;
   scanf("%d%d", &lobos, &n);

   char tablero[n][n + 1];
   for (int i = 0; i < n; ++i) {
      scanf("%s", &tablero[i][0]);
   }

   coordenada e, s;
   for (int i = 0; i < n; ++i) {
      for (int j = 0; j < n; ++j) {
         if (tablero[i][j] == 'E') {
            e = { i, j };
         } else if (tablero[i][j] == 'S') {
            s = { i, j };
         }
      }
   }

   bool visitado[n][n];
   for (int i = 0; i < n; ++i) {
      for (int j = 0; j < n; ++j) {
         visitado[i][j] = false;
      }
   }
   coordenada cola[n * n];
   coordenada *ini = cola, *fin = cola;
   visitado[e.fila][e.columna] = true, *fin++ = e;

   for (int d = 0; ini != fin; ++d) {
      for (coordenada *f = fin; ini != f; ++ini) {
         coordenada actual = *ini;
         if (actual.fila == s.fila && actual.columna == s.columna) {
            printf("%d\n", d);
            return 0;
         }

         coordenada vecinos[] = {
            { actual.fila - 1, actual.columna },
            { actual.fila + 1, actual.columna },
            { actual.fila, actual.columna - 1 },
            { actual.fila, actual.columna + 1 }
         };
         for (int i = 0; i < 4; ++i) {
            coordenada vecino = vecinos[i];
            if (0 <= vecino.fila && vecino.fila < n && 0 <= vecino.columna && vecino.columna < n && tablero[vecino.fila][vecino.columna] != '#' && !visitado[vecino.fila][vecino.columna]) {
               visitado[vecino.fila][vecino.columna] = true, *fin++ = vecino;
            }
         }
      }
   }

   printf("-1\n");
}
